#include "VertexData.h"

Geometry::DefaultVertexData::DefaultVertexData(unsigned int numv):Geometry::VertexData(numv)
{
	v = new float[numv*3];
	n = new float[numv*3];
	t = new float[numv*2];
}
Geometry::DefaultVertexData::~DefaultVertexData(void)
{
	delete[] v;
	delete[] n;
	delete[] t;
}

Geometry::VertexData *Geometry::DefaultVertexDataCreator(unsigned int numv)
{ 
	return new DefaultVertexData(numv); 
}


Geometry::DefaultIndexData::DefaultIndexData(unsigned int numi):Geometry::IndexData(numi)
{
	indices = new unsigned int[numi];	
}
Geometry::DefaultIndexData::~DefaultIndexData(void)
{
	delete[] indices;
}

Geometry::IndexData *Geometry::DefaultIndexDataCreator(unsigned int numi)
{ 
	return new DefaultIndexData(numi); 
}


Geometry::DefaultMultiIndexData::DefaultMultiIndexData(unsigned int numprims, unsigned int *numi):Geometry::MultiIndexData(numprims,numi)
{
	indices = new unsigned int*[numprims];	
	for (unsigned int i=0; i<numprims; i++)
		indices[i]=new unsigned int[numi[i]];
}
Geometry::DefaultMultiIndexData::~DefaultMultiIndexData(void)
{
	for (unsigned int i=0; i<GetNumPrims(); i++)
		delete[] indices[i];
	delete[] indices;
}

Geometry::MultiIndexData *Geometry::DefaultMultiIndexDataCreator(unsigned int numprims, unsigned int *numi)
{ 
	return new DefaultMultiIndexData(numprims,numi); 
}
